interface Options {
    replacement?: string;
    remove?: RegExp | string | string[];
    lower?: boolean;
    strict?: boolean;
    trim?: boolean;
    collapse?: boolean;
    multiCharMap?: MultiCharMap;
    fallback?: boolean;
    mode?: "pretty" | "rfc3986";
}
type CharMap = Record<string, string>;
type MultiCharMap = Record<string, string>;

declare const baseMap: CharMap;

declare function slugify(str: string, options?: Options): string;
interface SlugifierConfig {
    map?: CharMap;
    multiCharMap?: MultiCharMap;
    options?: Options;
}
declare function createSlugifier(config?: SlugifierConfig): (str: string, options?: Options) => string;
declare function extend(base: CharMap, ...extensions: CharMap[]): CharMap;
declare function extendMultiChar(base: MultiCharMap, ...extensions: MultiCharMap[]): MultiCharMap;

export { type CharMap, type MultiCharMap, type Options, type SlugifierConfig, baseMap, createSlugifier, extend, extendMultiChar, slugify };
